# InternetLangIdent

Language Identification for internet conversations

## Dependencies
 - Python >= 3.6
 - fasttext (0.9.2)
 - pycountry (20.7.3)
 - unidecode (1.2.0)

## Setup
The following set of commands clones the repository and downloads all necessary models and datasets
```sh
$ git clone https://gitlab.fi.muni.cz/nlp/internetlangident
$ cd internetlangident
$ make all
```

## Usage

### Custom FastText wrapper
 - the module includes its own FastText module along with preprocessing pipeline and the ability to decide unknown language
 - the module is availible inside of `custom_fasttext_wrapper` directory

Example Usage:
```py
from language_identifier import LanguageIdentifier

model = LanguageIdentifier()

language, confidence = model.classify_single("ahoj")
print(language, confidence)
```

Output:
```py
sk [0.99905926]
```

### Dictionary Identifier

### Ensemble
 - the module itself is located inside of `ensemble` directory
 - the original FastText model, custom FastText model, and the Dictionary identifier form and ensemble where the voting results are determined by a set of handcrafted rules

Example usage:

```py
from lang_ident_ensemble import LangIdentEnsemble

model = LangIdentEnsemble()

prediction, confidence = model.identify_language("hi there")
print(prediction, confidence)
```

Output:

```py
en array([1.25572915])
```

## Replicating the FastText model
